/*
 *                 Copyright (c) Apr 19 10:23:36  MTCC
 *          Created Sat Apr 19 10:23:36 1997 By Michael Thomas
 */

#ifndef h_crawl
#define h_crawl

#define CRL_INTRASITE 0         /* visit intrasite nodes once only */
#define CRL_INTRAFULL 1         /* view the entire tree, intrasite; some nodes
                                   may be visited more than once */
#define CRL_EXTRAFIRST 2        /* touch the first extranode site */
#define CRL_EXTRAFULL 3         /* loose the hounds */

#define CRL_LEAFVISIT 0x10000   /* normally we don't visit leaves outside of us */


struct flist 
{
    char * url;
    struct flist * flink;
    struct flist * stack;
    char * parent;
    short visited;
    short type;
};


/*
 * the action routine is called with this structure
 * when crawling through the name space.
 */

struct crawlnode 
{
    char * url;
    char * parent;
    htelm * file;
    int sts;
    int level;
    char type [256];
};

#endif
