#define SPAMDB "spam"


#define PEER_ENABLED 1          /* whether we should consider this in hdr */
#define PEER_ALLRULES 2         /* when updating, should we grab all rules
                                   from this peer? */
#define PEER_AUTOUPD 4          /* controls whether we should directly
                                   insert rules into the database, or
                                   create a todo shadow */
#define PEER_SHADOW 8           /* this is a shadow; url points to local name */

#define PEER_LOG    0xf0000000  /* mask for logger bits in local */
#define LOG_SHIFT   28
#define LOG_NORMAL  0           /* normal logging */
#define LOG_TRACK   4           /* track things more closely */
#define LOG_DEBUG   0xf         /* turn on debugging info */

#define MVERSION 1              /* the Mirror Version */

extern int sock;
extern hrec * in, * login,  * peers;

void error (char * fmt, ...);
void logf (int lvl, char * fmt, ...);
hrec * lookpeer ();
