
class hURL 
{
  
    String proto;
    String host;
    int port;
    String path;
    String file;

    // empty constructor
    hURL () 
    {}
    
    

private String
    stripdotdot (String path) 
    {
        int i;
        
        for (i = 0; i < path.length();) {
            if (p [i] == '.') {
                if (p [1] == '/') {
                    /* useless ./ */
                    strcpy (p, p+2);
                } else if (p [1] == '.' && p [2] == '/') {
                    char * t;
                    if (p-1 >= path && p [-1] == '/')
                        t = p-2;
                    else
                        t = p-1;
                    for (; t > path; t--)
                        if (* t == '/')
                            break;
                    if (t >= path)
                        strcpy (t, p+2);
                    p = t;
                } else
                    p++;
            } else if (p [0] == '/' && p [1] == '/') {
                /* gobble up the // in  /foo//bar/baz */
                strcpy (p, p+1);
                p++;
            }
            else
                p++;
        }
    }



/*
 * parse a URL into its components. I really should write
 * a regular expression parser for this.
 */

    parseurl (String url, hURL base) 
    {
    
        String nurl;
        String host;
        int i, urlp;
        
    
        if (url == null)
            url = "/";
        port = 80;

        /* special case of relative path name: use base url */    
        if (url.indexOf (':') < 0 && base != null) {
            if (url.charAt (0) == '/')
                nurl = base.proto + "://" + base.host + url;
            else {
                if (url.length () == 0 || url.charAt (0) == '#')
                    nurl = base.proto + "://" + base.host + base.path+base.file+url;
                
                else
                    nurl = base.proto + "://" + base.host + base.path+url;
                url = nurl;
            }
        } else if (url.length () == 0)
            url = "/";    
        if ((urlp = url.indexOf (':')) >= 0) {
            proto = url.substring (0, i);
        } else
            proto = "http";
        if (url.startsWith ("//", urlp)) {
            urlp += 2;
            /* optional port number? */
            if ((i = url.indexOf (':', urlp)) >= 0) {
                host = substring (urlp, i);
                urlp = i+1;                
                if ((i = url.indexOf ('/', urlp)) < 0)
                    i = url.length ();
                port = Integer.parseInt (
                    url.substring (i+1, i));
                urlp = i;
            } else if ((i = url.indexOf ('/', urlp)) >= 0) {
                host = substring (urlp, i);
                urlp = i;
            } else {
                host = url;
                url = "/";
            }        
        } else {
            host = getHostName ();
        }
        strcpy (out->path, url);
        stripdotdot (out->path);    /* strip any ./ and ../ in the path now */

        /* deal with parameters */
        if ((p = strchr (out->path+1, '?')) == 0) {
            /* place p at the last non null char. not guaranteed
               to deal with zero, but the for loop checks against
               that. */
            p = out->path+strlen (out->path)-1;
        } else
            p--;
    
        /* sort of a strrchr to find the last '/' in the real path*/
        for (p; p >= out->path+1; p--)
            if (* p == '/')
                break;
        if (* p != '/' || p == out->path)
            p = 0;        
    
        /* /path/... or /path */            
        if (p) {
            p++;
            strcpy (out->file, p);
            * p = 0;
        } else {
            /* if /~mike or /file.html */
            if (out->path [1] != '~') {    
                strcpy (out->file, out->path+1);
                out->path [1] = 0;
            } else {
                strcat (out->path, "/");
                out->file [0] = 0;
            }        
        }
        /* this is extremely sketchy. it should be something, but
           that something is a function of the HTTPD, not us. Punt
           for now; it means we won't always distinguish
           /foo/bar/ from /foo/bar/index.htm or somesuch. oh well.
           */
        if (out->file [0] == 0)
            strcpy (out->file, "index.html");
        if (strpbrk (out->path, " \t\n") || strpbrk (out->file, " \t\n"))
            return -1;
        return 0;
    }

       
            

    char * canonicalurl (URL * u) 
    {
        char * rv;
        int len;

        if (! strcmp (u->proto, "http") || ! strcmp (u->proto, "ftp")) {
            rv = malloc (strlen (u->proto)+3+strlen (u->host)+7+1+
                         strlen (u->path)+1+ strlen (u->file)+1);
            if (u->port == 80)
                sprintf (rv, "%s://%s%s%s", u->proto, u->host, u->path, u->file);
            else
                sprintf (rv, "%s://%s:%d%s%s", u->proto, u->host, u->port, u->path, u->file);
        } else {
            rv = malloc (strlen(u->proto)+1+strlen(u->file)+1);
            sprintf (rv, "%s:%s", u->proto, u->path);
        }
        return rv;
    }


}
