#ifndef h_search
#define h_search

typedef struct 
{
    int op;
#define E_EQ      0             
#define E_NEQ     1
#define E_GT      2
#define E_GTE     3
#define E_LT      4
#define E_LTE     5
#define E_REGEX   6
    hrecelm * val;
    struct CLAUSE * c;
} expr;

typedef struct CLAUSE
{
#define C_NOP  0
#define C_AND  1
#define C_OR   2
    int op;
    expr * e;
} clause;

#endif
