/*
 *                 Copyright (c) May  3 09:35:48  MTCC
 *	Author: Michael Thomas
 *	Module: spam.c
 *	Created: Sat May  3 09:35:48 1997
 *	Abstract:
 *	   a httpd based spam buster
 */

/* Edit History: 
 */

#include <html.h>
#include <time.h>
#include "spam.h"

main (int ac, char ** av) 
{
    char * p;

#ifdef DEBUG
    hputenv ("debug", "yes");
#else
    hputenv ("debug", "no");
#endif    
    in = hrgetparams (0, ac, av);
    preHTML ();
    sock = hminit (DBHOST, SPAMDB);
    if (sock < 0)
        error ("can't open spam database.");
#ifdef ADMIN
    /* a one day sessid should be OK */
    if (hinitlogin (DBHOST, "spam", "zz", 24*60*60) < 0)
        error ("can't start up login database.");
#endif
    readpeers ();    
    p = hrget (in, "cmd");    
    switch (* p) {        
        default:
        case 0:
        case 'l':
#ifdef ADMIN
            if (! strcmp (p, "listpeer")) {
                cklogin (in);
                listpeer (in);
            } else if (! strcmp (p, "log")) {
                cklogin (in);                
                showlog (in);
            } else {
                startlogin (in);
            } 
#else
            listspam (in);
#endif
            break;
        case 'h':
            hdrspam (in);
            break;
        case 'm':
#ifdef ADMIN            
            if (! strcmp (p, "miscpeer")) {
                cklogin (in);
                miscpeer (in);
            } else
#endif                
                mirrorspam (in);
            break;
#ifdef ADMIN
        case 's':
            cklogin (in);
            setlog (in);
            break;
        case 'e':
            cklogin (in);
            editspam (in);
            break;
        case 'u':
            if (! strcmp (p, "updpeer")) {
                cklogin (in);                            
                updpeer (in);
            } else
                loginspam (in);
            break;
        case 'p':
            cklogin (in);
            if (! strcmp (p, "purgelog"))
                purgelog (in);
            else
                parsespam (in);
            break;
        case 'a':
            cklogin (in);
            if (! strcmp (p, "addpeer"))
                addpeer (in);
            else
                addspam (in);
            break;
        case 'd':
            cklogin (in);
            delpeer (in);
            break;


#endif            
            
    }
    htdumpfile ();
}
