/*
 *                 Copyright (c) Apr 11 08:08:34  MTCC
 *	Author: Michael Thomas
 *	Module: hcond.c
 *	Created: Fri Apr 11 08:08:34 1997
 *	Abstract:
 *	   Conditionals and Includes
 */

/* Edit History: 
 */

package mtcc.libht;

import mtcc.libht.*;
import java.lang.*;



public class hcond 
{
    static hrec global;

    public static  void hputenv (String var, String val) 
    {
        hrec h;
        
        /* self initialize. */
        if (global == null)
            global = new hrec ();
        global.add (var, val);
    }

/* unlike its cousin hrget, this returns 0 if not
 * there, and the string if available.
 */

    public static String hgetenv (String var)
    {
         if (global == null)
             return null;
         return global.isvis (var);
    }

            

/* test the expansion of the condtional at element h */

    static int hcond (htelm h) 
    {
        token p = h.tk.getword (1);
        String gval;
        
        if (p == null)
            return 0;
        /* if not even part of the environment, bzzt. */
        if ((gval = hgetenv (p.name)) == null)
            return 0;
        
        /* eval if there a val (ie <$if foo=bar>) */
        if (p.flink != null && (p.flink.flags & token.TK_VAL) != 0) {
            if (gval.equals (p.flink.name)) 
                return 1;
            else
                return 0;
        } else
            return 1;
    }
}



    


