/*
 *                 Copyright (c) May 23 11:48:09  MTCC
 *	Author: Michael Thomas
 *	Module: htelm.java
 *	Created: Fri May 23 11:48:09 1997
 *	Abstract:
 *	   the basic data structure of tag and text elements
 */

/* Edit History: 
 */

package mtcc.libht;

import mtcc.libht.*;
import java.lang.*;


public class htelm 
{
    int type;
public static final int H_TXT = 0;
public static final int H_MISCTAG = 1;
public static final int H_FORM =  2;
public static final int H_SELECT = 3;
public static final int H_OPTION = 4;
public static final int H_TXTAREA = 5;
public static final int H_INPUT = 6;
public static final int H_RADIO = 7;
public static final int H_CHECK = 8;
public static final int H_HIDDEN =9;
public static final int H_SUBMIT =10;
public static final int H_RESET = 11;
public static final int H_PASSWORD =2;
public static final int H_TABLE = 13;
public static final int H_TBHDR = 14;
public static final int H_TBROW = 15;
public static final int H_TBCELL =16;
public static final int H_ANCHOR =17;
public static final int H_PSSTART = 1000;
public static final int H_MARKER = 1000; /* pseudo types, marker (gotomark) */
public static final int H_DATE =  1001;  /* insert date */
public static final int H_TABLEDEF = 1002;
public static final int H_IF =    1003;
public static final int H_INC =   1004;
public static final int H_SET =   1005;
public static final int H_ELSE =   1006;
public static final int H_NOTAG =   -1; // no tag at all. 
    htelm  flink;               /* forward, backward, and sublinks */
    htelm  blink;
    htelm  slink;
    htelm  ulink;
    StringBuffer body;          /* the text body */
    int len;                    /* current length */
    int lineno;
    token tk;

    // the constructor
    public htelm (int type, int lineno) 
    {
        this.type = type;
        this.body = new StringBuffer ();
        this.lineno = lineno;
    }

protected void
    addc (char ch) 
    {
        body.append (ch);
        len++;
    }

}

