/*
 *                 Copyright (c) Apr 21 17:07:07  MTCC
 *	Author: Michael Thomas
 *	Module: sysdep.c
 *	Created: Mon Apr 21 17:07:07 1997
 *	Abstract:
 *	   system dependant crap
 */

/* Edit History: 
 */


#include "html.h"

#ifdef WANTSNPRINTF

vsnprintf (char * s, int n, char * fmt, va_list ap) 
{
    int rv;
    /* just ignore overflow (cringe) */
    rv = vsprintf (s, fmt, ap);
    return rv;
}

snprintf (char * s, int n, char * fmt, ...) 
{
    va_list ap;
    int rv;
    
    VA_START (ap, fmt);
    rv = vsprintf (s, fmt, ap);
    va_end (ap);
    return rv;
}


#endif
